//@ sourceURL=expedienteDetail.js
/*!
 * Copyright 2021 E.J.I.E., S.A.
 *
 * Licencia con arreglo a la EUPL, Versión 1.1 exclusivamente (la "Licencia");
 * Solo podrá usarse esta obra si se respeta la Licencia.
 * Puede obtenerse una copia de la Licencia en
 *
 *      http://ec.europa.eu/idabc/eupl.html
 *
 * Salvo cuando lo exija la legislación aplicable o se acuerde por escrito,
 * el programa distribuido con arreglo a la Licencia se distribuye "TAL CUAL",
 * SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
 * Véase la Licencia en el idioma concreto que rige los permisos y limitaciones
 * que establece la Licencia.
 */

function getIndexSelectedTab(rupTabsElement){
	var children = rupTabsElement.children("ul").children("li ");
	var child = rupTabsElement.find("ul:first-child li[tabindex='0']")[0];
	return Array.prototype.indexOf.call(children,child );
}

function getNumberOfTabs(rupTabsElement){
	return rupTabsElement.children("ul").find("li").size();
}

function initTooltip(){
	/*Iniciar el tooltip*/
	$(".info-icon").rup_tooltip({
		content: {
			text: function(event, api) {
				let text = $(this).attr('info');
				text = text.replaceAll('\n', '<br/>');
				return text;
			}
		},
		position: {
			my: 'bottom left',  // Position my top left...
			at: 'top left', // at the bottom right of...
		},
		style: {
			classes: 'qtip-green qtip-large'
		}
	});
	
	$(".info-icon").on('dblclick', function (e) {
		let text = $(this).attr('info');
		text = text.replaceAll('\n', '<br/>');
		if($('.info-icon').attr('info') != null && text != ''){ 
			Ad74aUtils.openConfirmDialog(
				'dialogConfirm', 
				`${$.rup.i18n.app.dialog.title.observaciones}`, 
				text,  
				[
		        	{
		                text: $.rup.i18n.app.botonera.cerrar,
		                click: function () { 
		                    $('#dialogConfirm').rup_dialog('close'); 
		                },
		                btnType: $.rup.dialog.LINK
		                
		            }
		        ],
		        'custom_mid_dialog rup-message rup-message-ok overflow-y-auto'
			);
		}
    });
}

function actualizarCabecera(){
	
	$.rup_ajax({
	  url: $.rup.CTX_PATH + "expedientes/obtenerCabeceraExpediente",
	  type: 'GET',
      data : { "idExpediente00":idExpediente00},
	  success: function(res){
		  
		 //Insertamos la respuesta en el DOM
		 $("#spanDetalleCabecera")[0].innerHTML = res;
		 eval($("#scriptCabecera").html());
		 
		 //Volvemos a ejecutar el codigo JS necesario para los nuevos elementos del DOM
		 
		$("#mi_carpeta_resumen").click(function(){
		 	const url = urlMiCarpeta;
		 	const dni = $("#datos_generales_dni36").val();
		    const folderId = $("#datos_generales_folderid36").val();
		    const participantId = $("#expediente_participantID_detail").val();
		    const token = $("#token").val();
		    
		    const params = { 'R01HNoPortal' : 'true','R02NLang':$.rup.lang,'lang':$.rup.lang,'holdership':'1','personId':dni,'personName': dni,'folderId':folderId,'participantId':participantId,'appSessionTokenInv':token};
		   
		   
		    var form = document.createElement("form");
		
		    form.setAttribute("method", "post");
		    form.setAttribute("action", url);
		    form.setAttribute("target", "_blank");
		
		    for (let i in params) {
		        if (params.hasOwnProperty(i)) {
		            let input = document.createElement('input');
		            input.type = 'hidden';
		            input.name = i;
	                input.value = params[i];
	                form.appendChild(input);
		        }
		    }
		    
	        document.body.appendChild(form);          	                	        
	        form.submit();	                   
	        document.body.removeChild(form);
	 			 
		});
		
		initTooltip();
		
		 
		 Ad74aUtils.desBloquearInterfaz();
	  },
	  beforeSend: function(){
		  Ad74aUtils.bloquearInterfaz();
	  },
	  error: function(error){
		  Ad74aUtils.desBloquearInterfaz();
	  }
	});
	
	

}

jQuery(function($) {
	
	var loadingDiv;
	
	initRupI18nPromise.then(function() {
		
		//Mensaje de carga mientras la pestaña esta vacía de html
		loadingDiv = `<div class="row">
				<div class="col col-sm text-center">
				<div class="col col-sm text-center processing-container">
				<span class="loading">${$.rup.i18n.base.rup_blockUI.cargando}</span>
			</div>
		</div>`;
		

		
		initTabs();
		initComponentes();
		initControlEstado();
		/*setTimeout(() => {
			initTooltip();
		}, "3000");*/
		
	});
		
	
	
	
	
	function initComponentes(){
		
		actualizarCabecera();
		
		
		
		$("#expedientesDetail_form_feedback").rup_feedback ({
			  type: "ok",
			  delay: 3000,
			  fadeSpeed: 500,
			  block: false
		});
		

		let buttons = [];
		let botonFinalizar = {
			text: function () {
				return $.rup.i18n.app.botonera.finalizar;
			},
			id: 'Finalizar', // Campo obligatorio si se quiere usar desde el contextMenu
			css: "mdi mdi-check-bold",
			action : function(e, dt, node, config) {			
				alert("TODO");					
			}
		};
		
		if(estadoExpPendienteComSol == expedienteJSON.estados.idEstado30 ){
			buttons.push(botonFinalizar);
			$("#expedientesDetail_toolbar").rup_toolbar({buttons});
		}else{
			$("#expedientesDetail_toolbar").hide();
		}
			
	}
	
	let tabs = [];
	
	let tabSolicitud = {
		i18nCaption: "solicitud",
		url: $.rup.CTX_PATH + "expedientes/tabSolicitud/" + idExpediente00
	};
	let tabPresentacionServicio = {
		i18nCaption: "prestacionServicio",
		url: $.rup.CTX_PATH + "expedientes/tabPrestacionServicio/" + idExpediente00
	};
	let tabInformeSocial = {
		i18nCaption: "informeSocial",
		url: $.rup.CTX_PATH + "expedientes/tabInformeSocial/" + idExpediente00
	};
	let tabDocumentos = {
		i18nCaption: "documentos",
		url: $.rup.CTX_PATH + "expedientes/tabDocumentos/" + idExpediente00
	};
	let tabTramitacion = {
		i18nCaption: "tramitacion",
		url: $.rup.CTX_PATH + "expedientes/tabTramitacion/" + idExpediente00
	};

	//CARGAMOS LAS PESTAÑAS EN FUNCION DEL PROCEDIMIENTO ADMINISTRATIVO
	if(idProcedimientoALTA == expedienteJSON.idProcedimiento00 ){
		tabs.push(tabSolicitud);
		tabs.push(tabPresentacionServicio);
		if(tieneInformeSocial){tabs.push(tabInformeSocial)};
		tabs.push(tabDocumentos);
		tabs.push(tabTramitacion);
	}else if(idProcedimientoBAJA == expedienteJSON.idProcedimiento00 ){
		tabs.push(tabSolicitud);
		tabs.push(tabDocumentos);
		tabs.push(tabTramitacion);
	}else if(idProcedimientoINFORME == expedienteJSON.idProcedimiento00 ){
		tabs.push(tabSolicitud);
		tabs.push(tabDocumentos);
		tabs.push(tabTramitacion);
	}else if(idProcedimientoMODIFICACION == expedienteJSON.idProcedimiento00 ){
		tabs.push(tabSolicitud);
		if(tieneInformeSocial){tabs.push(tabInformeSocial)};
		tabs.push(tabDocumentos);
		tabs.push(tabTramitacion);
	}else if(idProcedimientoREVISION == expedienteJSON.idProcedimiento00 ){
		tabs.push(tabSolicitud);
		tabs.push(tabDocumentos);
		tabs.push(tabTramitacion);
	}else if(idProcedimientoNOTIFICACION_LIQUIDACION == expedienteJSON.idProcedimiento00 ){
		tabs.push(tabSolicitud);
		tabs.push(tabDocumentos);
		tabs.push(tabTramitacion);
	}
	if(idProcedimientoX87Tea1 == expedienteJSON.idProcedimiento00 || idProcedimientoX87Tea2 == expedienteJSON.idProcedimiento00 || idProcedimientoX87Tea4 == expedienteJSON.idProcedimiento00 ){
		tabs.push(tabSolicitud);
		tabs.push(tabPresentacionServicio);
		if(tieneInformeSocial){tabs.push(tabInformeSocial)};
		tabs.push(tabDocumentos);
		tabs.push(tabTramitacion);
	}

	/*Pestañas*/
	function initTabs(){
		$('#tabsDetalleExpedientes').rup_tabs({
			create: function (e, ui) {
				ui.panel.append(loadingDiv);
			},
			load: function (e, ui) {
				Ad74aUtils.desBloquearInterfaz();
				$(ui.panel).find(".tab-loading").remove();
				ui.tab.data( "loaded", true );
				
			},
			select: function (e, ui) {
				Ad74aUtils.bloquearInterfaz();
				if (ui.newPanel.is(":empty")) {					
					ui.newPanel.append(loadingDiv);													
				}
				actualizarCabecera();

			},
			tabs: tabs
		});
	}	
	
	
	function initControlEstado(){
		
		
		
	}	


});

